/*
#  -------------------------------------------------------------------
# This file is part of Rule2Phrase.
#
# Rule2Phrase is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Rule2Phrase is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Rule2Phrase.  If not, see <http://www.gnu.org/licenses/>.
# -------------------------------------------------------------------
*/

package es.ua.dlsi.hybridmt.apertiumphrasegenerator;

import java.util.List;

/**
 *
 * @author vmsanchez
 */
public class GeneratorCategory {
    private String catName;
    private int size;
    private List<String> lexicalForms;
    private int counter;
    private boolean endReached;

    public GeneratorCategory(String catName, List<String> lexicalForms) {
        this.catName = catName;
        this.size = lexicalForms.size();
        this.lexicalForms = lexicalForms;
        this.counter = 0;
        this.endReached=false;
        if(this.size==0)
             this.endReached=true;
    }

    public String getCurrentWord()
    {
        return lexicalForms.get(counter);
    }

    public boolean increment()
    {
        if(counter==0)
            endReached=false;
        counter++;
        if(counter>=size)
        {
            counter=0;
            endReached=true;
        }
        return endReached;
    }

    public boolean isEndReached() {
        return endReached;
    }

    public void setEndReached(boolean endReached) {
        this.endReached = endReached;
    }

    

    public String getCatName() {
        return catName;
    }

    public void setCatName(String catName) {
        this.catName = catName;
    }


    public int getCounter() {
        return counter;
    }

    public void setCounter(int counter) {
        this.counter = counter;
    }

    public List<String> getLexicalForms() {
        return lexicalForms;
    }

    public void setLexicalForms(List<String> lexicalForms) {
        this.lexicalForms = lexicalForms;
    }

    public int getSize() {
        return size;
    }

    public void setSize(int numberWords) {
        this.size = numberWords;
    }


}
