/*
#  -------------------------------------------------------------------
# This file is part of Rule2Phrase.
#
# Rule2Phrase is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Rule2Phrase is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Rule2Phrase.  If not, see <http://www.gnu.org/licenses/>.
# -------------------------------------------------------------------
*/

package es.ua.dlsi.hybridmt.apertiumphrasegenerator;

import es.ua.dlsi.hybridmt.apertiumphrasegenerator.trie.Trie;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author vitaka
 */
public class MultiChunkTrie {

     private Trie<String> trie;

    public MultiChunkTrie() {
        trie = new Trie<String>("");
    }


    public void addMultiChunk(List<String> chunks, String source)
    {
        List<String> in= new ArrayList<String>();
        in.addAll(chunks);
        in.add(source);
        trie.insertElement(in);
    }

    public List<String> getSources(List<String> chunks)
    {
        List<String> sources=new ArrayList<String>();

        Trie<String> subtrie=trie.getSubTrie(chunks, "");
        if(subtrie!=null)
        {
            List<List<String>> l= subtrie.getItemList();

            for(List<String> c: l)
            {
                if(c.size()==chunks.size()+2)
                {
                    String source=c.get(c.size()-1);
                    sources.add(source);
                }
            }
        }
        else
            System.err.println("ERROR: MUltichunk not found '"+Util.join(chunks, " ")+"'");
        return sources;
    }

    public List<List<String>> getMultiChunks()
    {
        return trie.getItemList();
    }
     
}
