/*
#  -------------------------------------------------------------------
# This file is part of Rule2Phrase.
#
# Rule2Phrase is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Rule2Phrase is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Rule2Phrase.  If not, see <http://www.gnu.org/licenses/>.
# -------------------------------------------------------------------
*/

package es.ua.dlsi.hybridmt.apertiumphrasegenerator;

import java.util.regex.Pattern;

/**
 *
 * @author vmsanchez
 */
public class ReplacementPattern {
    private Pattern pattern;
    private String source;
    private String replacement;
    private int numSourceWords;

    public ReplacementPattern(String source, int numSourceWords, String replacement) {
        this.source = source;
        this.replacement = replacement;
        this.pattern = Pattern.compile(Pattern.quote(source));
        this.numSourceWords=numSourceWords;
    }

    public Pattern getPattern() {
        return pattern;
    }

    public void setPattern(Pattern pattern) {
        this.pattern = pattern;
    }

    public String getReplacement() {
        return replacement;
    }

    public void setReplacement(String replacement) {
        this.replacement = replacement;
    }

    public String getSource() {
        return source;
    }

    public void setSource(String source) {
        this.source = source;
    }

    public int getNumSourceWords() {
        return numSourceWords;
    }

    public void setNumSourceWords(int numSourceWords) {
        this.numSourceWords = numSourceWords;
    }

    

    
}
