/*
#  -------------------------------------------------------------------
# This file is part of Rule2Phrase.
#
# Rule2Phrase is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Rule2Phrase is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Rule2Phrase.  If not, see <http://www.gnu.org/licenses/>.
# -------------------------------------------------------------------
*/
package es.ua.dlsi.hybridmt.apertiumphrasegenerator;

import java.util.Iterator;
import java.util.List;
import java.util.regex.Pattern;

/**
 *
 * @author vmsanchez
 */
public class Util {
    public static String join(List<String> s, String delimiter) {
    if (s == null || s.isEmpty()) return "";
    Iterator<String> iter = s.iterator();
    StringBuilder builder = new StringBuilder(iter.next());
    while( iter.hasNext() )
    {
        builder.append(delimiter).append(iter.next());
    }
    return builder.toString();
}
    
     public static String joinChunks(List<TrueChunk> s, String delimiter) {
    if (s == null || s.isEmpty()) return "";
    Iterator<TrueChunk> iter = s.iterator();
    StringBuilder builder = new StringBuilder(iter.next().getChunk());
    while( iter.hasNext() )
    {
        builder.append(delimiter).append(iter.next().getChunk());
    }
    return builder.toString();
}

     public static String joinChunksf(List<ChunkFragment> s, String delimiter) {
    if (s == null || s.isEmpty()) return "";
    Iterator<ChunkFragment> iter = s.iterator();
    StringBuilder builder = new StringBuilder(iter.next().getChunk());
    while( iter.hasNext() )
    {
        builder.append(delimiter).append(iter.next().getChunk());
    }
    return builder.toString();
}

      public static String joinSources(List<TrueChunk> s, String delimiter) {
    if (s == null || s.isEmpty()) return "";
    Iterator<TrueChunk> iter = s.iterator();
    StringBuilder builder = new StringBuilder(iter.next().getSource());
    while( iter.hasNext() )
    {
        builder.append(delimiter).append(iter.next().getSource());
    }
    return builder.toString();
}

     public static Pair<String> splitSourceAndTransfer(String src)
    {
         Pair<String> value=null;
         String[] pieces=src.split(Pattern.quote(" ||| "));
         if(pieces.length==2)
         {
            value=new Pair<String>(pieces[0].trim(), pieces[1].trim());
         }
         return value;
     }

    static String joinTransferDebug(List<TrueChunk> s, String delimiter) {
        if (s == null || s.isEmpty()) return "";
    Iterator<TrueChunk> iter = s.iterator();
    StringBuilder builder = new StringBuilder(iter.next().getDebugTransfer());
    while( iter.hasNext() )
    {
        builder.append(delimiter).append(iter.next().getDebugTransfer());
    }
    return builder.toString();
    }

    static String lowercaseApertiumWord(String apword)
    {
        StringBuilder builder=new StringBuilder(apword.trim());
        builder.setCharAt(1, Character.toLowerCase(builder.charAt(1)));
        return builder.toString();
    }
}
