/*
#  -------------------------------------------------------------------
# This file is part of Rule2Phrase.
#
# Rule2Phrase is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Rule2Phrase is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Rule2Phrase.  If not, see <http://www.gnu.org/licenses/>.
# -------------------------------------------------------------------
*/

package es.ua.dlsi.hybridmt.apertiumphrasegenerator.trie;

import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;

/**
 *
 * @author vmsanchez
 */
public class Node<T> {
    T data;
    Map<T,Node<T>> children;

    public Node(T basedata)
    {
        data = basedata;
        children= new HashMap<T,Node<T>>();
    }

    public Map<T, Node<T>> getChildren() {
        return children;
    }

    public void setChildren(Map<T, Node<T>> children) {
        this.children = children;
    }

    public T getData() {
        return data;
    }

    public void setData(T data) {
        this.data = data;
    }

    public Node<T> copy()
    {
        Node<T> copy= new Node<T>(data);
        for(Entry<T,Node<T>> entry: children.entrySet())
        {
            copy.children.put(entry.getKey(), entry.getValue().copy());
        }
        return copy;
    }
    
}
