# !/bin/bash

#  -------------------------------------------------------------------
# This file is part of Rule2Phrase.
#
# Rule2Phrase is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Rule2Phrase is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Rule2Phrase.  If not, see <http://www.gnu.org/licenses/>.
# -------------------------------------------------------------------


# Extracts lemmas and part-of-speech tags from an Apertium monolingual dictionary
# Creates a file for each PoS with all its lemmas
#Creates another file with the lexical forms which generate/come from multiword surface forms

# $1 : Apertium bin directory
# $2 : Dictionary file
# $3 : Directory where the extracted lemmas will be stored
# $4 : Apertium scripts directory
# $5 : "analysis" for analysis multiwords; "generation" for generation multiwords. Default is analysis

DEFAULTMW="analysis"

MW=${5:-$DEFAULTMW}

mkdir -p $3
$1/lt-expand "$2" |  sort | uniq | python $4/extractLemmasAndPOSv2.py "$3" "$MW"
