#!/usr/bin/python
# coding=utf-8
# -*- encoding: utf-8 -*-

#  -------------------------------------------------------------------
# This file is part of Rule2Phrase.
#
# Rule2Phrase is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Rule2Phrase is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Rule2Phrase.  If not, see <http://www.gnu.org/licenses/>.
# -------------------------------------------------------------------

import sys;

ENCODING='utf-8'

#Load allowed words
def loadAllowedWords(file):
	startingSymbol=u"WORD"
	inWordSection=False
	alWords=set()
	for line in open(file):
		line=line.decode(ENCODING).strip()
		if line.startswith(startingSymbol):
			if not inWordSection:
				inWordSection=True
			alWords.add(line[len(startingSymbol):].strip())
		else:
			if inWordSection:
				break
	return alWords

allowedWords=loadAllowedWords(sys.argv[1])
prefixFilteringStr=sys.argv[2]

if prefixFilteringStr == "prefix":
	prefixFiltering=True
else:
	prefixFiltering=False

print >>sys.stderr,str(len(allowedWords))+" words allowed loaded from ngrams"
for line in sys.stdin:
	line=line.decode(ENCODING).strip()
	lineLowCase=line[0:1]+line[1:2].lower()+line[2:]
	lineUpCase=line[0:1]+line[1:2].upper()+line[2:]
	if prefixFiltering:
		lineLowCaseClean=lineLowCase[1:-1]
		lineUpCaseClean=lineUpCase[1:-1]
		for allowedWord in allowedWords:
			if allowedWord.startswith(u"^"+lineLowCaseClean) or allowedWord.startswith(u"^"+lineUpCaseClean):
				print allowedWord.encode(ENCODING)
	else:
		if lineLowCase in allowedWords or lineUpCase in allowedWords:
			print line.encode(ENCODING)
	
