#!/usr/bin/python
# coding=utf-8
# -*- encoding: utf-8 -*-

#  -------------------------------------------------------------------
# This file is part of Rule2Phrase.
#
# Rule2Phrase is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Rule2Phrase is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Rule2Phrase.  If not, see <http://www.gnu.org/licenses/>.
# -------------------------------------------------------------------

import sys;

ENCODING='utf-8'

#Load allowed words
def loadAllowedWords(file):
	startingSymbol=u"WORD"
	inWordSection=False
	alWords=set()
	for line in open(file):
		line=line.decode(ENCODING).strip()
		if line.startswith(startingSymbol):
			if not inWordSection:
				inWordSection=True
			alWords.add(line[len(startingSymbol):].strip())
		else:
			if inWordSection:
				break
	return alWords

allowedWords=loadAllowedWords(sys.argv[1])
print >>sys.stderr,str(len(allowedWords))+" words allowed loaded from ngrams"
for line in sys.stdin:
	line=line.decode(ENCODING).strip()
	parts=line.split(u"|||")
	words=parts[0].strip().split(u"--")
	ok=True
	
	#debug
	#print >> sys.stderr, str(parts)
	#print >> sys.stderr, str(words)
	
	for word in words:
		word=word.strip()
		wordLowCase=word[0:1]+word[1:2].lower()+word[2:]
		wordUpCase=word[0:1]+word[1:2].upper()+word[2:]
		if not ( wordLowCase in allowedWords or  wordUpCase in allowedWords):
			#debug
			#print >> sys.stderr, word.strip().encode(ENCODING)+" is not allowed"
			
			ok=False
			break
	if ok:
		print line.encode(ENCODING)
	

