#! /bin/bash

#  -------------------------------------------------------------------
# This file is part of Rule2Phrase.
#
# Rule2Phrase is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Rule2Phrase is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Rule2Phrase.  If not, see <http://www.gnu.org/licenses/>.
# -------------------------------------------------------------------

SL=$1
TL=$2
MODES_DIR=$3

#sl_lex_pre-tl_debug.mode
FROMTRANSFERINC=`cat $MODES_DIR/${SL}-${TL}.mode | awk -F"apertium-transfer /" '{ print $2 }' | tr -d '\n'`
APERTIUMPATH=`cat $MODES_DIR/${SL}-${TL}.mode | perl -ne 'print  if s/.*[| ](\/[^ ]+\/)apertium-tagger.*/\1/' | tr -d '\n'`
FROMTRANSFER="${APERTIUMPATH}apertium-transfer /$FROMTRANSFERINC"

FROMTRANSFERSTEP1INC=`echo "$FROMTRANSFER" | awk -F"apertium-interchunk" '{ print $1 }'`
FROMTRANSFERSTEP2INC=`echo "$FROMTRANSFER" | awk -F"apertium-interchunk" '{ print $2 }'`

FROMTRANSFERSTEP1=`echo "$FROMTRANSFERSTEP1INC" | sed -r 's/\|[^|]*$//'`
FROMTRANSFERSTEP2=`echo "${APERTIUMPATH}apertium-interchunk$FROMTRANSFERSTEP2INC"`

echo "$FROMTRANSFERSTEP1" | sed -r 's/(apertium-transfer)/\1 -d/' > $MODES_DIR/${SL}_lex_pre-${TL}_step1_debug.mode

FROMTRANSFERSTEP2DEBUGINC=`echo "$FROMTRANSFERSTEP2" | sed -r 's/(apertium-interchunk)/\1 -d/' | sed -r 's/(apertium-postchunk)/\1 -d/'`

FROMTRANSFERSTEP2DEBUGINCPART1=`echo "$FROMTRANSFERSTEP2DEBUGINC" | awk -F"${APERTIUMPATH}lt-proc -p" '{ print $1 }'`
FROMTRANSFERSTEP2DEBUGINCPART2=`echo "$FROMTRANSFERSTEP2DEBUGINC" | awk -F"${APERTIUMPATH}lt-proc -p" '{ print $2 }'`

echo "$FROMTRANSFERSTEP2DEBUGINCPART1"'sed  -r "s:(^|\]?transfer\\\\\\]\\])(([^[]|\\[[^\\\\])+)(\\[\\\\\\[debug-postchunk):\1\2 [ \\\\[debug-postgen \2 debug-postgen\\]] \4:g" | '"${APERTIUMPATH}lt-proc -p$FROMTRANSFERSTEP2DEBUGINCPART2" > $MODES_DIR/${SL}_lex_pre-${TL}_step2_debug.mode


#sl_lex-tl_debug.mode
FROMPRETRANSFERINC=`cat $MODES_DIR/${SL}-${TL}.mode | awk -F"apertium-pretransfer" '{ print $2 }' | tr -d '\n'`
FROMPRETRANSFER="${APERTIUMPATH}apertium-pretransfer$FROMPRETRANSFERINC"

FROMPRETRANSFERSTEP1INC=`echo "$FROMPRETRANSFER" | awk -F"apertium-interchunk" '{ print $1 }'`
FROMPRETRANSFERSTEP2INC=`echo "$FROMPRETRANSFER" | awk -F"apertium-interchunk" '{ print $2 }'`

FROMPRETRANSFERSTEP1=`echo "$FROMPRETRANSFERSTEP1INC" | sed -r 's/\|[^|]*$//'`
FROMPRETRANSFERSTEP2=`echo "${APERTIUMPATH}apertium-interchunk$FROMPRETRANSFERSTEP2INC"`

echo "$FROMPRETRANSFERSTEP1" | sed -r 's/(apertium-transfer)/\1 -d/' | sed -r 's/(apertium-pretransfer)/\1 -d/' > $MODES_DIR/${SL}_lex-${TL}_step1_debug.mode

FROMPRETRANSFERSTEP2DEBUGINC=`echo "$FROMPRETRANSFERSTEP2" | sed -r 's/(apertium-interchunk)/\1 -d/' | sed -r 's/(apertium-postchunk)/\1 -d/'`

FROMPRETRANSFERSTEP2DEBUGINCPART1=`echo "$FROMPRETRANSFERSTEP2DEBUGINC" | awk -F"${APERTIUMPATH}lt-proc -p" '{ print $1 }'`
FROMPRETRANSFERSTEP2DEBUGINCPART2=`echo "$FROMPRETRANSFERSTEP2DEBUGINC" | awk -F"${APERTIUMPATH}lt-proc -p" '{ print $2 }'`

echo "$FROMPRETRANSFERSTEP2DEBUGINCPART1"'sed  -r "s:(^|\]?pretransfer\\\\\\]\\])(([^[]|\\[[^\\\\])+)(\\[\\\\\\[debug-postchunk):\1\2 [ \\\\[debug-postgen \2 debug-postgen\\]] \4:g" | '"${APERTIUMPATH}lt-proc -p$FROMPRETRANSFERSTEP2DEBUGINCPART2" > $MODES_DIR/${SL}_lex-${TL}_step2_debug.mode


#sl_lex_analyzed_with_tl-sl.mode

DICTDIR=` cat $MODES_DIR/${SL}-${TL}.mode | awk -F"${SL}-${TL}.automorf.bin" '{ print $1 }' | awk -F"lt-proc " '{ print $2 }' | tr -d '\n'`  

echo "${APERTIUMPATH}lt-proc "'$1'" ${DICTDIR}${SL}-${TL}.automorfinv.bin" > $MODES_DIR/${SL}_lex_analyzed_with_${TL}-${SL}.mode

#sl-tl-pretransfer
TOTRANSFERINC=`cat $MODES_DIR/${SL}-${TL}.mode | awk -F"apertium-transfer /" '{ print $1 }' | sed -r 's/\|[^|]*$//' | tr -d '\n'`
TOTRANSFER=`echo "$TOTRANSFERINC" | awk -F"apertium-pretransfer" '{ print $2 }' | tr -d '\n'`
echo "$APERTIUMPATH""apertium-pretransfer$TOTRANSFER" > $MODES_DIR/${SL}-${TL}-pretransfer.mode

#sl-sl_lex_pretransfer_to_tl
echo "$TOTRANSFERINC" > $MODES_DIR/${SL}-${SL}_lex_pretransfer_to_${TL}.mode



