# /bin/bash

#  -------------------------------------------------------------------
# This file is part of Rule2Phrase.
#
# Rule2Phrase is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Rule2Phrase is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Rule2Phrase.  If not, see <http://www.gnu.org/licenses/>.
# -------------------------------------------------------------------

SRC_DEF=es
TARGET_DEF=pt
PAIR_DEF=es-pt

SRC=${1:-$SRC_DEF}
TARGET=${2:-$TARGET_DEF}
PAIR=${3:-$PAIR_DEF}
DIR=$4
SRCDICTIONARY=$5
APERTIUMBINDIR=$6
MYSCRIPTSDIR=$7
EXTRASCRIPTSDIR=$8
TARGETMULTIWORDS=$9

#DIR=/work2/vmsanchez/hybridmt/common/dictionary$4-$SRC-$TARGET

mkdir -p $DIR
$APERTIUMBINDIR/lt-expand $SRCDICTIONARY  | LC_ALL=C  sort | uniq  | split -l 10000 - $DIR/split_

rm -f $DIR/dictcorpus.all

echo "Generating dictionary corpus $SRC - $TARGET $9"

for file in `ls $DIR/split_*`; do

echo "Processing $file"

cat $file |  python $MYSCRIPTSDIR/generateCorpusFromDictionary.py  $file.$SRC.upperprev $file.$TARGET.upperprev $file.als.dprev  $SRC $TARGET $TARGETMULTIWORDS ${10}

cat  $file.$SRC.upperprev | python $MYSCRIPTSDIR/tokenizeWithALignments.py -l $SRC > $file.$SRC.upperplusals
cat  $file.$TARGET.upperprev | python $MYSCRIPTSDIR/tokenizeWithALignments.py -l $TARGET > $file.$TARGET.upperplusals

cat $file.$SRC.upperplusals | python $MYSCRIPTSDIR/cutPhraseTable.py -f 1 > $file.$SRC.upper
cat $file.$TARGET.upperplusals | python $MYSCRIPTSDIR/cutPhraseTable.py -f 1 | sed -r "s:^([^/]*)/.*:\1:" > $file.$TARGET.upper

cat $file.$SRC.upperplusals | python $MYSCRIPTSDIR/cutPhraseTable.py -f 2 > $file.$SRC.upperonlyals
cat $file.$TARGET.upperplusals | python $MYSCRIPTSDIR/cutPhraseTable.py -f 2  > $file.$TARGET.upperonlyals

python $MYSCRIPTSDIR/pastePhraseTable.py $file.$SRC.upperonlyals $file.als.dprev $file.$TARGET.upperonlyals | python $MYSCRIPTSDIR/joinAlignments.py > $file.als.d

$EXTRASCRIPTSDIR/lowercase.perl <$file.$SRC.upper | sed -r "s/[ ]+/ /g" >$file.$SRC.d
$EXTRASCRIPTSDIR/lowercase.perl <$file.$TARGET.upper| sed -r "s/[ ]+/ /g" >$file.$TARGET.d

python $MYSCRIPTSDIR/pastePhraseTable.py  $file.$SRC.d $file.$TARGET.d $file.als.d >> $DIR/dictcorpus.all

done

cat $DIR/dictcorpus.all | LC_ALL=C sort | uniq | grep -E "^.*[^ ].* \|\|\| .*[^ ].* \|\|\|" | python $MYSCRIPTSDIR/filterEmptyPhrases.py -f 1,2 >$DIR/dictcorpus.nodup

python $MYSCRIPTSDIR/cutPhraseTable.py -f 1 <$DIR/dictcorpus.nodup > $DIR/dictcorpus.$SRC
python $MYSCRIPTSDIR/cutPhraseTable.py -f 2 <$DIR/dictcorpus.nodup > $DIR/dictcorpus.$TARGET
python $MYSCRIPTSDIR/cutPhraseTable.py -f 3 <$DIR/dictcorpus.nodup > $DIR/dictcorpus.als

python $MYSCRIPTSDIR/cutPhraseTable.py -f 1,2 < $DIR/dictcorpus.nodup | sed -r 's/$/ |||/' | LC_ALL=C sort | uniq  |gzip > $DIR/dictcorpus.gz

#rm $DIR/split_*
#rm $DIR/dictsplit_*
