#!/usr/bin/python
# coding=utf-8
# -*- encoding: utf-8 -*-

#  -------------------------------------------------------------------
# This file is part of Rule2Phrase.
#
# Rule2Phrase is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Rule2Phrase is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Rule2Phrase.  If not, see <http://www.gnu.org/licenses/>.
# -------------------------------------------------------------------

import re, sys, string, apertium,getopt;
from expandPTLib import *

NUMALSSRC=2
NUMALSTARGET=3

removeMWAlignments=False

try:
	opts, args = getopt.getopt(sys.argv[1:], "s:t:r", ["sourceElements=","targetElements=","removeMWAlignments"])
except getopt.GetoptError, err:
	# print help information and exit:
	print str(err) # will print something like "option -a not recognized"
	sys.exit(2)

for o, a in opts:
	if o in ("-s", "--sourceElements"):
		NUMALSSRC=int(a)
	elif o in ("-t", "--targetElements"):
		NUMALSTARGET=int(a)
	elif o in ("-r", "--removeMWAlignments"):
		removeMWAlignments=True
	else:
		assert False, "unhandled option"

numLine=0
for line in sys.stdin:
	line=line.decode('utf-8')
	parts=line.split(u" ||| ")
	
	numLine+=1
	
	if len(parts) >= NUMALSSRC+NUMALSTARGET+2:
		
		alsList=list()
		partIndex=1
		finalAlignments=SentenceAlignments()
		
		for i in range(NUMALSSRC):
			sa=SentenceAlignments()
			sa.parse(parts[partIndex])
			alsList.append(sa)
			partIndex+=1
		
		partIndex+=1
		
		for i in range(NUMALSTARGET):
			sa=SentenceAlignments()
			sa.parse(parts[partIndex])
			alsList.append(sa)
			partIndex+=1		

		finalAlignments.merge(alsList,removeMWAlignments)
		print finalAlignments.toStringMinusOne().encode('utf-8')
		
	else:
		#print >> sys.stderr, "WARNING: invalid alignments line "
		print >> sys.stderr, "WARNING: invalid alignments. line "+str(numLine)
		print ""
