#!/usr/bin/python
# coding=utf-8
# -*- encoding: utf-8 -*-

#  -------------------------------------------------------------------
# This file is part of Rule2Phrase.
#
# Rule2Phrase is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Rule2Phrase is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Rule2Phrase.  If not, see <http://www.gnu.org/licenses/>.
# -------------------------------------------------------------------

import getopt,sys, codecs;

try:
	opts, args = getopt.getopt(sys.argv[1:], "d:", ["delimiter="])
except getopt.GetoptError, err:
	# print help information and exit:
	print str(err) # will print something like "option -a not recognized"
	usage()
	sys.exit(2)
delimiter=" ||| "
for o, a in opts:
	if o in ("-d","--delimiter"):
		delimiter=a

files=list()
for arg in args:
	f=codecs.open(arg,encoding='utf-8',mode='r')
	files.append(f)

endfile=False

if len(files) > 0:
	while not endfile:
		toprint=list()
		for i in range(len(files)):
			f=files[i]
			line=f.readline()
			if line != u"":
				line=line.strip()
				toprint.append(line)
				if i<len(files)-1:
					toprint.append(delimiter)
			else:
				endfile=True
		if not endfile:
			print u''.join(toprint).encode('utf-8')

for f in files:
	f.close()
